public extension MicItem {
  static func shouldResetActivity(_ c: MicItemContext) -> Bool? {
    if
      c.activityDate.isRecent,
      let end = c.activityDate.value
    {
      let now = Date()
      return now < end
    }

    if c.timeout {
      return false
    }

    return nil
  }

  static func shouldResetTimeout(_ c: MicItemContext) -> TimeInterval? {
    if
      c.activityDate.isRecent,
      let end = c.activityDate.value
    {
      let timeout = end.timeIntervalSinceNow
      return timeout > 0 ? timeout : nil
    }

    return nil
  }
}
